DCMTK: DiBaseLUT Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
DiBaseLUT Class Reference

Base class to handle look-up tables. More...

Inheritance diagram for DiBaseLUT:

## Public Member Functions
| DiBaseLUT (const Uint32 count=0, const Uint16 bits=0)
| constructor
virtual | ~DiBaseLUT ()
| destructor
Uint32 | getCount () const
| get number of LUT entries
Uint16 | getBits () const
| get number of bits per entry
Uint32 | getFirstEntry (const Uint32=0) const
| get index of first LUT entry.
Sint32 | getFirstEntry (const Sint32) const
| get index of first LUT entry.
Uint32 | getLastEntry (const Uint32=0) const
| get index of last LUT entry.
Sint32 | getLastEntry (const Sint32) const
| get index of last LUT entry.
Uint16 | getValue (const Uint16 pos) const
| get value of specified LUT entry
Uint16 | getValue (const Uint32 pos) const
| get value of specified LUT entry.
Uint16 | getValue (const Sint32 pos) const
| get value of specified LUT entry.
Uint16 | getFirstValue () const
| get value of first LUT entry.
Uint16 | getLastValue () const
| get value of last LUT entry.
const Uint16 * | getData () const
| get pointer to LUT data
Uint16 | getMinValue () const
| get minimum value of the LUT.
Uint16 | getMaxValue () const
| get maximum value of the LUT.
Uint32 | getAbsMaxRange () const
| get absolute value range of the LUT entries.
int | isValid () const
| check whether LUT is valid
const char * | getExplanation () const
| get LUT explanation string
virtual OFBool | operator== (const DiBaseLUT &lut)
| compares current LUT with specified LUT

## Protected Member Functions
| DiBaseLUT (Uint16 *buffer, const Uint32 count=0, const Uint16 bits=0)
| constructor
int | compare (const DiBaseLUT *lut)
| compares current LUT with specified LUT

## Protected Attributes
Uint32 | Count
| number of LUT entries
Uint16 | FirstEntry
| first input value mapped (FIV)
Uint16 | Bits
| number of bits per entry
Uint16 | MinValue
| minimum LUT value
Uint16 | MaxValue
| maximum LUT value
int | Valid
| status code, indicating whether LUT is valid
OFString | Explanation
| LUT explanation string.
const Uint16 * | Data
| pointer to lookup table data
Uint16 * | DataBuffer
| pointer to data buffer (will be deleted in the destructor)

## Detailed Description

Base class to handle look-up tables.

## Constructor & Destructor Documentation

## ◆ DiBaseLUT() [1/2]

DiBaseLUT::DiBaseLUT | ( | const Uint32 | count = 0,
|  | const Uint16 | bits = 0 )

constructor

Parameters

  count | number of LUT entries
  bits | number of bits per entry

Referenced by compare(), operator==(), and DiLookupTable::operator==().

## ◆ DiBaseLUT() [2/2]

DiBaseLUT::DiBaseLUT | ( | Uint16 * | buffer,
|  | const Uint32 | count = 0,
|  | const Uint16 | bits = 0 )
| protected

constructor

Parameters

  buffer | pointer to array with LUT entries
  count | number of LUT entries
  bits | number of bits per entry

## Member Function Documentation

## ◆ compare()

int DiBaseLUT::compare | ( | const DiBaseLUT * | lut | ) |
| protected

compares current LUT with specified LUT

Parameters

  lut | LUT to be compared with the current one

Returns
  true if LUTs are not equal (1 = invalid LUT, 2 = descriptor differs, 3 = data differs) false (0) otherwise

References DiBaseLUT().

## ◆ getAbsMaxRange()

Uint32 DiBaseLUT::getAbsMaxRange | ( |  | ) | const
| inline

get absolute value range of the LUT entries.

The maximum value which could be stored with the specified bit depth is calculated.

Returns
  absolute range of LUT entries

References Bits, and DicomImageClass::maxval().

Referenced by DiMonoOutputPixelTemplate< T1, T2, T3 >::nowindow(), DiMonoOutputPixelTemplate< T1, T2, T3 >::sigmoid(), DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::window().

## ◆ getBits()

Uint16 DiBaseLUT::getBits | ( |  | ) | const
| inline

get number of bits per entry

Returns
  number of bits per entry

References Bits.

Referenced by DiMonoOutputPixelTemplate< T1, T2, T3 >::nowindow(), DiMonoOutputPixelTemplate< T1, T2, T3 >::sigmoid(), DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::window().

## ◆ getCount()

Uint32 DiBaseLUT::getCount | ( |  | ) | const
| inline

get number of LUT entries

Returns
  number of LUT entries

References Count.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), DiMonoOutputPixelTemplate< T1, T2, T3 >::nowindow(), DiMonoOutputPixelTemplate< T1, T2, T3 >::sigmoid(), DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::window().

## ◆ getData()

const Uint16 * DiBaseLUT::getData | ( |  | ) | const
| inline

get pointer to LUT data

Returns
  pointer to LUT data

References Data.

## ◆ getExplanation()

const char * DiBaseLUT::getExplanation | ( |  | ) | const
| inline

get LUT explanation string

Returns
  LUT explanation string if successful, NULL otherwise

References Explanation.

## ◆ getFirstEntry() [1/2]

Sint32 DiBaseLUT::getFirstEntry | ( | const Sint32 |  | ) | const
| inline

get index of first LUT entry.

First input value mapped (FIV) in LUT descriptor is SS -> 16 bit signed. ... or the previous pixel transformation requires a signed LUT input value.

(#)param dummy (used to distinguish between signed and unsigned methods)

Returns
  index of first LUT entry

References FirstEntry.

## ◆ getFirstEntry() [2/2]

Uint32 DiBaseLUT::getFirstEntry | ( | const Uint32 | = 0 | ) | const
| inline

get index of first LUT entry.

First input value mapped (FIV) in LUT descriptor is US -> 16 bit unsigned. ... or the previous pixel transformation requires an unsigned LUT input value.

(#)param dummy (used to distinguish between signed and unsigned methods)

Returns
  index of first LUT entry

References FirstEntry.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getFirstValue()

Uint16 DiBaseLUT::getFirstValue | ( |  | ) | const
| inline

get value of first LUT entry.

Returns
  value of first LUT entry

References Data.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getLastEntry() [1/2]

Sint32 DiBaseLUT::getLastEntry | ( | const Sint32 |  | ) | const
| inline

get index of last LUT entry.

FIV in LUT descriptor is SS -> 16 bit signed. ... or the previous pixel transformation requires a signed LUT input value.

(#)param dummy (used to distinguish between signed and unsigned methods)

Returns
  index of first LUT entry

References Count, and FirstEntry.

## ◆ getLastEntry() [2/2]

Uint32 DiBaseLUT::getLastEntry | ( | const Uint32 | = 0 | ) | const
| inline

get index of last LUT entry.

FIV in LUT descriptor is US -> 16 bit unsigned. ... or the previous pixel transformation requires an unsigned LUT input value.

(#)param dummy (used to distinguish between signed and unsigned methods)

Returns
  index of last LUT entry

References Count, and FirstEntry.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getLastValue()

Uint16 DiBaseLUT::getLastValue | ( |  | ) | const
| inline

get value of last LUT entry.

Returns
  value of last LUT entry

References Count, and Data.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getMaxValue()

Uint16 DiBaseLUT::getMaxValue | ( |  | ) | const
| inline

get maximum value of the LUT.

Returns
  maximum value of the LUT

References MaxValue.

Referenced by DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getMinValue()

Uint16 DiBaseLUT::getMinValue | ( |  | ) | const
| inline

get minimum value of the LUT.

Returns
  minimum value of the LUT

References MinValue.

Referenced by DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut().

## ◆ getValue() [1/3]

Uint16 DiBaseLUT::getValue | ( | const Sint32 | pos | ) | const
| inline

get value of specified LUT entry.

FIV in LUT descriptor is SS -> 16 bit signed. ... or the previous pixel transformation requires a signed LUT input value.

Parameters

  pos | position in the LUT to be returned

Returns
  value of specified LUT entry

References Data, and FirstEntry.

## ◆ getValue() [2/3]

Uint16 DiBaseLUT::getValue | ( | const Uint16 | pos | ) | const
| inline

get value of specified LUT entry

Parameters

  pos | position in the LUT to be returned

Returns
  value of specified LUT entry

References Data.

Referenced by DiMonoInputPixelTemplate< T1, T2, T3 >::modlut(), DiMonoOutputPixelTemplate< T1, T2, T3 >::nowindow(), DiMonoOutputPixelTemplate< T1, T2, T3 >::overlay(), DiMonoOutputPixelTemplate< T1, T2, T3 >::sigmoid(), DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::window().

## ◆ getValue() [3/3]

Uint16 DiBaseLUT::getValue | ( | const Uint32 | pos | ) | const
| inline

get value of specified LUT entry.

FIV in LUT descriptor is US -> 16 bit unsigned. ... or the previous pixel transformation requires an unsigned LUT input value.

Parameters

  pos | position in the LUT to be returned

Returns
  value of specified LUT entry

References Data, and FirstEntry.

## ◆ isValid()

int DiBaseLUT::isValid | ( |  | ) | const
| inline

check whether LUT is valid

Returns
  status, true if valid, false otherwise

References Valid.

Referenced by DiMonoOutputPixelTemplate< T1, T2, T3 >::DiMonoOutputPixelTemplate(), DiMonoOutputPixelTemplate< T1, T2, T3 >::createDisplayLUT(), DiMonoOutputPixelTemplate< T1, T2, T3 >::nowindow(), DiMonoOutputPixelTemplate< T1, T2, T3 >::overlay(), DiMonoOutputPixelTemplate< T1, T2, T3 >::sigmoid(), DiMonoOutputPixelTemplate< T1, T2, T3 >::voilut(), and DiMonoOutputPixelTemplate< T1, T2, T3 >::window().

## ◆ operator==()

virtual OFBool DiBaseLUT::operator== | ( | const DiBaseLUT & | lut | ) |
| virtual

compares current LUT with specified LUT

Parameters

  lut | LUT to be compared with the current one

Returns
  OFTrue if LUTs are equal, OFFalse otherwise

Reimplemented in DiLookupTable.

References DiBaseLUT().

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dibaslut.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2